unit MainUnit; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, LCLProc, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, FileUtil, Buttons, windows, FileCtrl;

type

  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Button1: TButton;
    Button2: TButton;
    FileListBox1: TFileListBox;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    Timer1: TTimer;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
    function ExtractLzPfad(DatenStr: String): String;
    function ExtractFPCVersion(DatenStr: String): String;
    function ExtractDateiName(DatenStr: String): String;
  public
    { public declarations }
  end;

var
  Form1: TForm1; 

implementation

{ TForm1 }
var
  StartPfad, LzPfad, LazarusPfad, LazarusPfad2, BackUpPfad, fpcPfad, fpcVersion: String;
  Ti: Integer;
  Wiederherstellen: Boolean;
  

function TForm1.ExtractLzPfad(DatenStr: String): String;
var
  ErstPos, LetztPos, Count: Integer;
begin
   ErstPos := Pos('"', DatenStr) + 1;
   LetztPos := Length(DatenStr) - 2;
   Count := LetztPos - ErstPos;
   ExtractLzPfad := Copy(DatenStr, Erstpos, Count);
end;

function TForm1.ExtractFPCVersion(DatenStr: String): String;
var
  ErstPos, LetztPos, Count: Integer;
begin
   ErstPos := Pos('fpc', DatenStr);
   LetztPos := ErstPos + 10;
   Count := LetztPos - ErstPos;
   ExtractFPCVersion := Copy(DatenStr, Erstpos, Count);
end;

function TForm1.ExtractDateiName(DatenStr: String): String;
var
  ErstPos, LetztPos, Count: Integer;
begin
   ErstPos := 1;
   LetztPos := Pos('.', DatenStr) + 3;
   Count := LetztPos;
   ExtractDateiName := Copy(DatenStr, Erstpos, Count);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   MyStringList: TStringList;
   hFormIcon: THandle;
   ZeitStempel, S: String;
   i: Integer;
   F: TextFile;

begin
  hFormIcon := LoadIcon(hInstance, 'FORMICON');
  SetClassLong(self.Handle, GCL_HICON, hFormIcon);
  SetClassLong(self.Handle, GCL_HICONSM, hFormIcon);
  ZeitStempel := DateTimeToStr(Now);
  ZeitStempel := StringReplace(ZeitStempel, ':', '.' ,[rfReplaceAll, rfIgnoreCase]);
  Ti := 1;
  StartPfad := ExtractFilePath(application.exename);
  LazarusPfad := StartPfad + 'lazarus\';
  LazarusPfad2 := StartPfad + 'lazarus';
  BackUpPfad := StartPfad + 'Backup\';
  FileListBox1.Directory := BackupPfad;
  If FileExists(LazarusPfad + 'environmentoptions.xml') = True Then
    begin
      AssignFile(F, LazarusPfad + 'environmentoptions.xml');
      Reset     (F);
      while not eof(F) do
        begin
          Readln(F, S);
// Alten LazarusPfad ermitteln
          If Pos('<LazarusDirectory Value="', S) > 0 Then
            begin
              LzPfad := ExtractLzPfad(S);
            end;
// FPC Version ermitteln
          If Pos('<CompilerFilename Value="', S) > 0 Then
            begin
              FPCVersion := ExtractFPCVersion(S);
              fpcPfad := LazarusPfad + FPCVersion + 'bin\i386-win32\';
            end;
        end;
      CloseFile(F);
    end;
  If FileListBox1.Count > 60 Then
     begin
       Wiederherstellen := True;
       If MessageDlg('Die Anzahl der Backupdateien ist auf ber 60 angewachsen.' + #13#10 +
                     'Sollen die Backups jetzt komplett gelscht werden?' + #13#10 +
                     'Bei "Nein" mssen Sie sich manuell darum kmmern.', mtConfirmation,
       [mbYes, mbNo], 0) = mrYes Then
          begin
            For i := 0 to FileListBox1.Count - 1 do
               begin
                 DeleteFile(PChar(BackUpPfad + FileListBox1.Items.Strings[i]));
               end;
          end;
     end;
  Wiederherstellen := False;
  If FileExists(LazarusPfad + 'environmentoptions.xml') = True Then
     begin
       MyStringList := TStringList.Create;
       MyStringList.LoadFromFile(LazarusPfad + 'environmentoptions.xml');
       MyStringList.SaveToFile(BackUpPfad + 'environmentoptions.xml vom ' + ZeitStempel + ' Uhr.bak');
       MyStringList.Free;
     end;
  If FileExists(LazarusPfad + 'helpoptions.xml') = True Then
     begin
       MyStringList := TStringList.Create;
       MyStringList.LoadFromFile(LazarusPfad + 'helpoptions.xml');
       MyStringList.SaveToFile(BackUpPfad + 'helpoptions.xml vom ' + ZeitStempel + ' Uhr.bak');
       MyStringList.Free;
     end;
  If FileExists(LazarusPfad + 'projtemplate.xml') = True Then
     begin
       MyStringList := TStringList.Create;
       MyStringList.LoadFromFile(LazarusPfad + 'projtemplate.xml');
       MyStringList.SaveToFile(BackUpPfad + 'projtemplate.xml vom ' + ZeitStempel + ' Uhr.bak');
       MyStringList.Free;
     end;
  If FileExists(LazarusPfad + 'inputhistory.xml') = True Then
     begin
       MyStringList := TStringList.Create;
       MyStringList.LoadFromFile(LazarusPfad + 'inputhistory.xml');
       MyStringList.SaveToFile(BackUpPfad + 'inputhistory.xml vom ' + ZeitStempel + ' Uhr.bak');
       MyStringList.Free;
     end;
  If FileExists(LazarusPfad + 'includelinks.xml') = True Then
     begin
       MyStringList := TStringList.Create;
       MyStringList.LoadFromFile(LazarusPfad + 'includelinks.xml');
       MyStringList.SaveToFile(BackUpPfad + 'includelinks.xml vom ' + ZeitStempel + ' Uhr.bak');
       MyStringList.Free;
     end;
  If FileExists(fpcPfad + 'fpc.cfg') = True Then
     begin
       MyStringList := TStringList.Create;
       MyStringList.LoadFromFile(fpcPfad + 'fpc.cfg');
       MyStringList.SaveToFile(BackUpPfad + 'fpc.cfg vom ' + ZeitStempel + ' Uhr.bak');
       MyStringList.Free;
     end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
   Button1.Visible := False;
   Button2.Visible := False;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if Wiederherstellen = False Then
     begin
       Ti := Ti + 1;
       If Ti =  2 Then Label1.Caption := 'Lazarus wird fr den Start vorbereitet!';
       if Ti =  6 Then Button1.Click;
       if Ti =  6 Then
         begin
           Label1.Caption := 'Lazarus wird jetzt gestartet!';
           BitBtn4.Enabled := False;
         end;
       if Ti = 10 Then Button2.Click;
       if Ti = 11 Then Close;
     end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  F: TextFile;
  S, NS: String;
  MyStringList: TStringList;

begin
// Alte Pfade durch neue ersetzen
  If FileExists(LazarusPfad + 'environmentoptions.xml') = True Then
    begin
      MyStringList := TStringList.Create;
      AssignFile(F, LazarusPfad + 'environmentoptions.xml');
      Reset     (F);
      while not eof(F) do
        begin
          Readln(F, S);
          NS := StringReplace(S, LzPfad, LazarusPfad2,[rfReplaceAll, rfIgnoreCase]);
          MyStringList.Add(NS);
        end;
      CloseFile(F);
      MyStringList.SaveToFile(LazarusPfad + 'environmentoptions.xml');
      MyStringList.Free;
    end;
  If FileExists(LazarusPfad + 'helpoptions.xml') = True Then
    begin
      MyStringList := TStringList.Create;
      AssignFile(F, LazarusPfad + 'helpoptions.xml');
      Reset     (F);
      while not eof(f) do
         begin
           Readln(F, S);
           NS := StringReplace(S, LzPfad, LazarusPfad2,[rfReplaceAll, rfIgnoreCase]);
           MyStringList.Add(NS);
         end;
      CloseFile (F);
      MyStringList.SaveToFile(LazarusPfad + 'helpoptions.xml');
      MyStringList.Free;
    end;
  If FileExists(LazarusPfad + 'projtemplate.xml') = True Then
    begin
      MyStringList := TStringList.Create;
      AssignFile(F, LazarusPfad + 'projtemplate.xml');
      Reset     (F);
      while not eof(f) do
         begin
           Readln(F, S);
           NS := StringReplace(S, LzPfad, LazarusPfad2,[rfReplaceAll, rfIgnoreCase]);
           MyStringList.Add(NS);
         end;
      CloseFile (F);
      MyStringList.SaveToFile(LazarusPfad + 'projtemplate.xml');
      MyStringList.Free;
    end;
  If FileExists(LazarusPfad + 'inputhistory.xml') = True Then
    begin
      MyStringList := TStringList.Create;
      AssignFile(F, LazarusPfad + 'inputhistory.xml');
      Reset     (F);
      while not eof(f) do
         begin
           Readln(F, S);
           NS := StringReplace(S, LzPfad, LazarusPfad2,[rfReplaceAll, rfIgnoreCase]);
           MyStringList.Add(NS);
         end;
      CloseFile (F);
      MyStringList.SaveToFile(LazarusPfad + 'inputhistory.xml');
      MyStringList.Free;
    end;
  If FileExists(LazarusPfad + 'includelinks.xml') = True Then
    begin
      MyStringList := TStringList.Create;
      AssignFile(F, LazarusPfad + 'includelinks.xml');
      Reset     (F);
      while not eof(f) do
         begin
           Readln(F, S);
           NS := StringReplace(S, LzPfad, LazarusPfad2,[rfReplaceAll, rfIgnoreCase]);
           MyStringList.Add(NS);
         end;
      CloseFile (F);
      MyStringList.SaveToFile(LazarusPfad + 'includelinks.xml');
      MyStringList.Free;
    end;
  If FileExists(fpcPfad + 'fpc.cfg') = True Then
    begin
      MyStringList := TStringList.Create;
      AssignFile(F, fpcPfad + 'fpc.cfg');
      Reset     (F);
      while not eof(F) do
        begin
          Readln(F, S);
          NS := StringReplace(S, LzPfad, LazarusPfad2,[rfReplaceAll, rfIgnoreCase]);
          MyStringList.Add(NS);
        end;
      CloseFile(F);
      MyStringList.SaveToFile(fpcPfad + 'fpc.cfg');
      MyStringList.Free;
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  If FileExists(LazarusPfad + 'Lazarus.exe') Then
  shellexecute(handle,nil, PChar(LazarusPfad + 'Lazarus.exe'), '', PChar(LazarusPfad), 6);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  DateiName: String;
  MyStringList: TStringList;
begin
  If FileListBox1.SelCount > 0 Then
    begin
      DateiName := ExtractDateiName(Label3.Caption);
      If DateiName = LowerCase('fpc.cfg') Then
         begin
           MyStringList := TStringList.Create;
           MyStringList.LoadFromFile(FileListBox1.FileName);
           MyStringList.SaveToFile(fpcpfad + 'fpc.cfg');
           MyStringList.Free;
           MessageDlg('Die Datei ' + DateiName + ' wurde wieder hergestellt.', mtInformation,
          [mbOk], 0);
         end else
         begin
           MyStringList := TStringList.Create;
           MyStringList.LoadFromFile(FileListBox1.FileName);
           MyStringList.SaveToFile(LazarusPfad + DateiName);
           MyStringList.Free;
           MessageDlg('Die Datei ' + DateiName + ' wurde wieder hergestellt.', mtInformation,
          [mbOk], 0);
         end;
    end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  If FileExists(StartPfad + 'PortabelLazarus.exe') Then
  shellexecute(handle,nil, PChar(StartPfad + 'PortabelLazarus.exe'), '', PChar(StartPfad), 6);
  Close;
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
var
  I: Integer;
  S: String;

begin
  For i := 0 to FileListBox1.Count - 1 do
    begin
      If FileListBox1.Selected[i] Then S := S + FileListBox1.Items.Strings[i] + #13#10;
    end;
  If MessageDlg('Soll(en) die Datei(en) ' + #13#10 + S + ' gelscht werden?', mtConfirmation,
  [mbYes, mbNo], 0) = mrYes Then
    begin
      For i := 0 to FileListBox1.Count - 1 do
        begin
          If FileListBox1.Selected[i] Then DeleteFile(PChar(BackUpPfad + FileListBox1.Items.Strings[i]));
        end;
      FileListBox1.UpdateFileList;
      If FileListBox1.SelCount = 0 Then
        begin
          Label3.Caption := '';
          BitBtn1.Enabled := True;
        end;
    end;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
begin
  FileListBox1.Directory := BackupPfad;
  FileListBox1.UpdateFileList;
  Wiederherstellen := True;
  Form1.Height := 670;
  Form1.Top := 10;
  BitBtn4.Enabled := False;
  Label1.Caption := 'Wiederherstellung ist Gestartet!';
end;

procedure TForm1.FileListBox1Click(Sender: TObject);
begin
  If FileListBox1.SelCount < 1 Then
    begin
      Label3.Caption := '';
      BitBtn1.Enabled := True;
    end;
  If FileListBox1.SelCount = 1 Then
    begin
      Label3.Caption := ExtractFileName(FileListBox1.FileName);
      BitBtn1.Enabled := True;
    end;
  If FileListBox1.SelCount > 1 Then
    begin
      Label3.Caption := 'Es wurden ' + IntToStr(FileListBox1.SelCount) + ' Dateien ausgewhlt!';
      BitBtn1.Enabled := False;
    end;
end;


initialization
  {$I mainunit.lrs}

end.

